' *** Zahnrad-Zeichenprogramm ***
' Version berarbeitet; es wurde erneuert:
'           - Anpassung an die Normung
'           - Neu lassen sich auch V-Verzahnungen erzeugen
' (c) 1990, 1997 by Andreas Meile
' Neuerungen: - speziell fr ausgefllte Zahnrder entworfen
'             - moderner, objektbasierter Design
'             - Zahnradszene wird von einer Textdatei eingelesen und
'               am Bildschirm eingepasst dargestellt

TYPE Zahnrad
  lx AS SINGLE  ' X-Koordinate des Mittelpunktes (Benutzereinheiten)
  ly AS SINGLE  ' Y-Koordinate des Mittelpunktes (Benutzereinheiten)
  lal AS SINGLE ' Stellungswinkel des 1. Zahns in 
  m AS SINGLE   ' Modul (Benutzereinheiten)
  z AS INTEGER  ' Zhnezahl
  x AS SINGLE   ' Profilverschiebungsfaktor gemss Norm (0=unkorrigiert)
  hff AS SINGLE ' Fusshhenfaktor (bei genormten Rder normalerweise 1.25)
  haf AS SINGLE ' Kopfhhenfaktor (bei genormten Rder normalerweise 1)
  al AS SINGLE  ' Eingriffswinkel in  (bei genormten Rder normalerweise 20)
END TYPE

DECLARE SUB AktualisiereLimiten (z AS Zahnrad)
DECLARE SUB SetzeBereich (xi!, xa!, yi!, ya!)
DECLARE SUB ZeichneZahnrad (z AS Zahnrad, Fa%)
DECLARE SUB BerechneNeulage (a!, nz%, w!, zref AS Zahnrad, zerg AS Zahnrad)

DIM SHARED Pi!, xBa!, yBa!, fx!, fy!, k!
DIM SHARED xMin!, xMax!, yMin!, yMax!, Efl%
DIM zr(1 TO 50) AS Zahnrad, omega%(1 TO 50), Fa%(1 TO 50)

Pi! = 4! * ATN(1!)

CLS
PRINT "Zahnradzeichenprogramm mit Animation"
PRINT "(c) 1990, 1997 by Andreas Meile, CH-8242 Hofen SH"
PRINT
INPUT "Datei mit Vorgelegedefinition"; d$

' Standardwerte fr das erste Rad
Zi% = 1
zr(Zi%).lx = 0!
zr(Zi%).ly = 0!
zr(Zi%).lal = 0!
zr(Zi%).m = 1!
zr(Zi%).z = 20
zr(Zi%).x = 0!
zr(Zi%).hff = 1.25
zr(Zi%).haf = 1!
zr(Zi%).al = 20!
omega%(Zi%) = 1
Fa%(Zi%) = 1
Abst! = 0!
nz% = 0
w! = 0!

OPEN d$ FOR INPUT AS 1
WHILE NOT EOF(1)
  LINE INPUT #1, z$
  ' Kommentar wegschneiden
  t% = INSTR(z$, "%")
  IF t% THEN
    z$ = LEFT$(z$, t% - 1)
  END IF
  t% = INSTR(z$, "=")
  IF t% THEN   ' Gltiger Befehl liegt vor
    Wert$ = MID$(z$, t% + 1)
    SELECT CASE LCASE$(LEFT$(z$, t% - 1))
    CASE "lagex"
      zr(Zi%).lx = VAL(Wert$)
    CASE "lagey"
      zr(Zi%).ly = VAL(Wert$)
    CASE "lage", "position"
      p% = INSTR(Wert$, " ")
      zr(Zi%).lx = VAL(LEFT$(Wert$, p% - 1))
      zr(Zi%).ly = VAL(MID$(Wert$, p% + 1))
    CASE "stellung"
      zr(Zi%).lal = VAL(Wert$)
    CASE "modul", "m"
      zr(Zi%).m = VAL(Wert$)
    CASE "z"
      zr(Zi%).z = VAL(Wert$)
    CASE "x", "korr"
      zr(Zi%).x = VAL(Wert$)
    CASE "hf"
      zr(Zi%).hff = VAL(Wert$) / zr(Zi%).m
    CASE "ha"
      zr(Zi%).haf = VAL(Wert$) / zr(Zi%).m
    CASE "hff"
      zr(Zi%).hff = VAL(Wert$)
    CASE "haf"
      zr(Zi%).haf = VAL(Wert$)
    CASE "eingriff", "alpha", ""
      zr(Zi%).al = VAL(Wert$)
    CASE "drehzahl", "n", "omega", "speed"
      omega%(Zi%) = VAL(Wert$)
    CASE "a", "abstand"
      Abst! = VAL(Wert$)
    CASE "nz"
      nz% = VAL(Wert$)
    CASE "winkel", "w"
      w! = VAL(Wert$)
    CASE "farbe"
      Fa%(Zi%) = VAL(Wert$)
    CASE "anrad"
      ba% = VAL(Wert$)
      Zi% = Zi% + 1
      BerechneNeulage Abst!, nz%, w!, zr(ba%), zr(Zi%)
      Fa%(Zi%) = Fa%(ba%)
      omega%(Zi%) = -omega%(ba%)
      Abst! = 0!
      nz% = 0
    CASE ELSE
      PRINT "Nicht verstndliche Zeile:"
      PRINT z$
      END
    END SELECT
  END IF
WEND
CLOSE 1

Efl% = -1
FOR i% = 1 TO Zi%
  AktualisiereLimiten zr(i%)
NEXT i%

' Limiten auf 4:3 anpassen

IF 3! * (xMax! - xMin!) > 4! * (yMax! - yMin!) THEN
  h! = (yMin! + yMax!) / 2!
  yMin! = h! - (xMax! - xMin!) * 3! / 8!
  yMax! = h! + (xMax! - xMin!) * 3! / 8!
ELSE
  h! = (xMin! + xMax!) / 2!
  xMin! = h! - (yMax! - yMin!) * 2! / 3!
  xMax! = h! + (yMax! - yMin!) * 2! / 3!
END IF

' Zuerst stehend zeichnen

SCREEN 12
CLS
SetzeBereich xMin!, xMax!, yMin!, yMax!
FOR i% = 1 TO Zi%
  ZeichneZahnrad zr(i%), Fa%(i%)
NEXT i%
d$ = INPUT$(1)

' Und jetzt noch animiert

SCREEN 7
SetzeBereich xMin!, xMax!, yMin!, yMax!
FOR i% = 0 TO 7
  SCREEN , , i%, i%
  CLS
  FOR j% = 1 TO Zi%
    ZeichneZahnrad zr(j%), Fa%(j%)
    zr(j%).lal = zr(j%).lal + CSNG(45 * omega%(j%)) / CSNG(zr(j%).z)
  NEXT j%
NEXT i%

dt! = 3600! / 2! ^ 16!
t! = TIMER
i% = 0
WHILE INKEY$ = ""
  t! = t! + dt!
  WHILE TIMER < t!
  WEND
  SCREEN , , i%, i%
  i% = i% + 1 AND 7
WEND

SCREEN 0
WIDTH 80, 25
END

' Umgrenzungen aktualisieren
SUB AktualisiereLimiten (z AS Zahnrad)
  h! = z.m * (CSNG(z.z) / 2! + z.haf + z.x)
  IF z.lx - h! < xMin! OR Efl% THEN
    xMin! = z.lx - h!
  END IF
  IF z.lx + h! > xMax! OR Efl% THEN
    xMax! = z.lx + h!
  END IF
  IF z.ly - h! < yMin! OR Efl% THEN
    yMin! = z.ly - h!
  END IF
  IF z.ly + h! > yMax! OR Efl% THEN
    yMax! = z.ly + h!
  END IF
  Efl% = 0
END SUB

' Neues Zahnrad anhand der Daten
SUB BerechneNeulage (a!, nz%, w!, zref AS Zahnrad, zerg AS Zahnrad)
  ' Eingangsparameter:
  ' a!                     : Achsabstand; betrgt er 0, dann wird eine
  '                        : V-Null-Verzahnung berechnet
  ' nz%                    : Neue Zhnezahl; beim Wert 0 berechnet das Pro-
  '                        : gramm eine Zhnezahl, die mglichst nahe an
  '                        : die V-Null-Verzahnung herankommt; der Korrek-
  '                        : turfaktor wird dabei automatisch angepasst
  ' w!                     : Lagewinkel, vom letzten Rad aus gesehen, in 

  ' Umkopieren
  zerg.m = zref.m
  zerg.hff = zref.hff
  zerg.haf = zref.haf
  zerg.al = zref.al
  IF a! = 0! THEN
    a! = CSNG(zref.z + nz%) * zref.m / 2!
    zerg.x = -zref.x
    nz1% = nz%
  ELSE
    IF nz% = 0 THEN
      nz1% = CINT(2! * a! / zref.m) - zref.z
    ELSE
      nz1% = nz%
    END IF
    h3! = zref.al / 180! * Pi!
    h1! = zref.m * CSNG(zref.z + nz1%) * COS(h3!) / 2! / a!
    h2! = SQR(1! - h1! * h1!) / h1!
    zerg.x = CSNG(zref.z + nz1%) * ((h2! - ATN(h2!) + h3!) / TAN(h3!) - 1!) / 2! - zref.x
  END IF
  zerg.lx = zref.lx + a! * COS(w! / 180! * Pi!)
  zerg.ly = zref.ly + a! * SIN(w! / 180! * Pi!)
  zerg.lal = w! - 180! + 180! / CSNG(nz1%) + (w! - zref.lal) * CSNG(zref.z) / CSNG(nz1%)
  zerg.z = nz1%
END SUB

' Koordinatenbereich setzen
SUB SetzeBereich (xi!, xa!, yi!, ya!)
  xBr% = 0
  WHILE POINT(xBr%, 0) <> -1
    xBr% = xBr% + 1
  WEND
  yBr% = 1
  WHILE POINT(0, yBr%) <> -1
    yBr% = yBr% + 1
  WEND
  fx! = CSNG(xBr%) / (xa! - xi!)
  fy! = CSNG(yBr%) / (ya! - yi!)
  k! = fx! / fy!
  xBa! = xi! + .5 / fx!
  yBa! = ya! - .5 / fy!
END SUB

' Zahnrad zeichnen
SUB ZeichneZahnrad (z AS Zahnrad, Fa%)
  px! = (z.lx - xBa!) * fx!
  py! = (yBa! - z.ly) * fy!
  my! = z.m * fy!
  r! = my! * CSNG(z.z) / 2!
  rf! = r! - my! * (z.hff - z.x)
  rf2! = rf! * rf!
  ra! = r! + my! * (z.haf + z.x)
  ra2! = ra! * ra!
  ryao% = CINT(INT(py! - ra!))
  ryau% = CINT(INT(py! + ra!))
  ryfo% = CINT(INT(py! - rf!))
  ryfu% = CINT(INT(py! + rf!))
  lalr! = z.lal / 180! * Pi!
  alr! = z.al / 180! * Pi!
  rg! = r! * COS(alr!)
  ky! = 1! / (rg! * rg!)
  kx! = ky! / (k! * k!)
  teilw! = 2! * Pi! / CSNG(z.z)
  psi! = teilw! / 4! - alr! + TAN(alr!) * (1! + z.x * 2! / CSNG(z.z))
  FOR y% = ryao% + 1 TO ryau%
    y! = py! - CSNG(y%)
    h! = k! * SQR(ra2! - y! * y!)
    x1% = CINT(INT(px! - h!))
    x2% = CINT(INT(px! + h!))
    IF y% > ryfo% AND y% <= ryfu% THEN
      a% = x2%
      h! = k! * SQR(rf2! - y! * y!)
      x2% = CINT(INT(px! - h!))
      GOSUB FlankenZeichnen
      x1% = CINT(INT(px! + h!))
      IF x1% > x2% THEN
        LINE (x2% + 1, y%)-(x1%, y%), Fa%, BF
      END IF
      x2% = a%
      GOSUB FlankenZeichnen
    ELSE
      GOSUB FlankenZeichnen
    END IF
  NEXT y%
EXIT SUB

FlankenZeichnen:
  FOR x% = x1% + 1 TO x2%
    x! = CSNG(x%) - px!
    IF x! = 0! THEN
      IF y! > 0! THEN
        phi! = Pi! / 2!
      ELSE
        phi! = 1.5 * Pi!
      END IF
    ELSEIF x! < 0! THEN
      phi! = ATN(k! * y! / x!) + Pi!
    ELSE
      phi! = ATN(k! * y! / x!)
    END IF
    phi! = phi! - lalr!
    phi! = phi! - teilw! * INT(phi! / teilw!)
    IF phi! > teilw! / 2! THEN
      phi! = teilw! - phi!
    END IF
    d! = x! * x! * kx! + y! * y! * ky!
    IF d! < 1! THEN
      IF phi! < psi! THEN
        PSET (x%, y%), Fa%
      END IF
    ELSE
      bet! = SQR(d! - 1!)
      IF phi! < psi! - bet! + ATN(bet!) THEN
        PSET (x%, y%), Fa%
      END IF
    END IF
  NEXT x%
RETURN
END SUB

